var mongojs = require('mongojs');

var db2 = mongojs("netmedia:netmedia@ds117829.mlab.com:17829/netmedia", ["posts"]);

var express = require('express');
var app = express();

app.set('view engine', 'ejs');

var bodyParser = require('body-parser');
var urlencodedParser = bodyParser.urlencoded({ extended: true });
app.use(urlencodedParser); // for parsing application/x-www-form-urlencoded

app.listen(3000, function () {
  console.log('Server listening on port 3000!');
});


app.get('/', function (req, res) {
  db2.posts.find({}, function(err, saved) {
    if (err || !saved) {
      console.log("No results");
    }
    else {
      var dataToGiveToRenderer = {"nameOfDataArrayOnPage": saved};
      res.render("index.ejs", dataToGiveToRenderer);
    }
  }); 
});


app.get('/json', function (req, res) {

	// We want to return things that are newer than the last timestamp from the client
	// Convert to a number rather than a string
  var lastTimestamp = Number(req.query.timestamp);

  db2.posts.find({timestamp: {$gt: lastTimestamp}}, function(err, saved) {
    if (err || !saved) {
      console.log("No results");
    }
    else {
      var dataToGiveToRenderer = {"nameOfDataArrayOnPage": saved};
      //res.render("index.ejs", dataToGiveToRenderer);

      res.send(dataToGiveToRenderer);
    }
  }); 

});


app.get('/getpost', function(req, res) {

  db.find({}, function(err, dataFromServer) {

        res.send(dataFromServer[req.query.postid]);
      
    });

});

app.get('/search', function(req, res) {
  var query = new RegExp(req.query.q, 'i');
  db2.posts.find({"keywords": query}, 
    function(err, saved) {
      if( err || !saved) console.log("No results");
      else res.send(saved);
  });
});


app.post('/formpost', function(req, res) {

  //console.log(req);
  console.log("The User Submitted: " + req.body.title + " " + req.body.post + " " + req.body.keywords);
  
  req.body.timestamp = Date.now();

  db2.posts.save(req.body, function(err, saved) {
    if( err || !saved ) console.log("Not saved");
    else console.log("Saved");
  });

  res.redirect("/");

});

app.use(express.static('public'));


console.log("I made this cool file on the server");
